from tools import target_maker
import pandas as pd
import numpy as np

def test_make_complete_feature():
    df = get_data(n_rows=100, n_citizens=10)
    settings = dict({'threshold_weeks': 8, 'threshold_training': 10})
    res = target_maker.make_complete_target(df, settings)
    assert res.shape[0] > 0
    assert res['Complete'] is not None

def test_make_fall_feature():
    df = get_data(n_rows=100, n_citizens=10)
    settings = dict({'threshold_weeks': 8, 'threshold_training': 10})
    res = target_maker.make_fall_target(df, settings)
    assert res.shape[0] > 0
    assert res['Fall'] is not None

def get_data(n_rows, n_citizens):
    df = pd.DataFrame()
    df['NumberCompleted'] = np.random.randint(0, 5, n_rows)
    df['NumberTraining'] = np.random.randint(0, 5, n_rows)
    df['NumberScreening'] = np.random.randint(0, 5, n_rows)
    df['NumberSplit'] = np.random.randint(0, 5, n_rows)
    df['NumberWeeks'] = np.random.randint(0, 5, n_rows)
    df['NumberFalls'] = np.random.randint(0, 5, n_rows)
    df['MeanEvaluation'] = np.random.randint(0, 5, n_rows)
    df['NeedsReason'] = ['NeedsReason'] * n_rows
    df['PhysicsReason'] = ['PhysicsReason'] * n_rows
    df['HasFallRisk'] = [True] * n_rows
    df['CitizenId'] = np.random.randint(0, n_citizens, n_rows)
    return df